﻿Imports Wiker.WIDatabase
Imports System.Collections.ObjectModel
Imports System.Text
Module Module1

    Sub Main()
    Dim WIDB As WIDatabase
        Dim ColumnDataStr As String
        Dim ColumnDataInt As Integer
        Dim ColumnDataBool As Boolean
        Dim StrB As StringBuilder
        Dim DBInfo As CDatabaseInfo
        Dim Conditions As Collection(Of CCondition)

        ColumnDataBool = False
        ColumnDataInt = 0
        ColumnDataStr = ""

        ' Create DatabaseInfo object with login info  

        DBInfo = New CDatabaseInfo()
        DBInfo.DatabaseType = eDatabaseType.SQLite
        DBInfo.Location = "\WIDatabase\Samples"
        DBInfo.DBName = "SQLite.db3"
        DBInfo.Password = ""
        DBInfo.Port = 0
        DBInfo.Username = ""

        ' Create WIDatabase object 

        WIDB = New WIDatabase(DBInfo)

        ' Calling Select.Clear() ensures we starting with a new select statement. 

        WIDB.Search.Clear()

        ' The Column Class is used to choose columns to be returned 

        WIDB.Search.Column("tblCompany", "CompanyID")
        WIDB.Search.Column("tblCompany", "AddressID")
        WIDB.Search.Column("Name")
        WIDB.Search.Column("LogoID")
        WIDB.Search.Column("WebSite")
        WIDB.Search.Column("Active")
        WIDB.Search.Column("Address1")
        WIDB.Search.Column("Address2")
        WIDB.Search.Column("City")
        WIDB.Search.Column("State")
        WIDB.Search.Column("ZipCode")
        WIDB.Search.Column("P1", "Number", "CompanyPhone")
        WIDB.Search.Column("P2", "Number", "CompanyFax")

        ' Select.Table: The 'Main' table from which the data will originate 

        WIDB.Search.Table("tblCompany")
        WIDB.Search.Condition("tblCompany", "CompanyID", eOperator.Equal, 15)

        ' Select.Join: Used to 'connect' related tables. 

        WIDB.Search.Join("tblAddress", "AddressID", eOperator.Equal, "tblCompany", "AddressID", eJoinType.Left)
        WIDB.Search.Join("tblImage", "ImageID", eOperator.Equal, "tblCompany", "LogoID", eJoinType.Left)

        Conditions = New Collection(Of CCondition)()
        Conditions.Add(New CCondition("P1", "CompanyID", eOperator.Equal, "tblCompany", "CompanyID"))
        Conditions.Add(New CCondition(eLogic.[AND]))
        Conditions.Add(New CCondition("P1", "Type", eOperator.Equal, 2))
        WIDB.Search.Join("tblPhone", "P1", Conditions, eJoinType.Left)

        Conditions = New Collection(Of CCondition)()
        Conditions.Add(New CCondition("P2", "CompanyID", eOperator.Equal, "tblCompany", "CompanyID"))
        Conditions.Add(New CCondition(eLogic.[AND]))
        Conditions.Add(New CCondition("P2", "Type", eOperator.Equal, 4))
        WIDB.Search.Join("tblPhone", "P2", Conditions, eJoinType.Left)

        ' Select.Execute() prepares the statement to be sent to the Database 

        WIDB.Search.Execute()

        Console.WriteLine("| CompanyID | AddressID | Name | LogoID | WebSite | Active | Address1 | Address2 | City | State | ZipCode | CompanyPhone | CompanyFax |")

        ' Select.Read() reads the next row from the returned data 

        While WIDB.Search.Read()
            StrB = New StringBuilder()

            ' Select.Get obtains the value of the named column via an out parameter 

            WIDB.Search.[Get]("CompanyID", ColumnDataInt)
            StrB.AppendFormat("| {0} ", ColumnDataInt)

            WIDB.Search.[Get]("AddressID", ColumnDataInt)
            StrB.AppendFormat("| {0} ", ColumnDataInt)

            WIDB.Search.[Get]("Name", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.Search.[Get]("LogoID", ColumnDataInt)
            StrB.AppendFormat("| {0} ", ColumnDataInt)

            WIDB.Search.[Get]("WebSite", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.Search.[Get]("Active", ColumnDataBool)
            StrB.AppendFormat("| {0} ", ColumnDataBool)

            WIDB.Search.[Get]("Address1", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.Search.[Get]("Address2", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.Search.[Get]("City", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.Search.[Get]("State", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.Search.[Get]("ZipCode", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.Search.[Get]("CompanyPhone", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.Search.[Get]("CompanyFax", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            Console.WriteLine(StrB.ToString())
        End While

        ' Good practice is to close the DB when finished 

        WIDB.Close()

    End Sub

End Module
