﻿Imports Wiker.WIDatabase
Imports System.Text
Module Module1

    Sub Main()
    Dim WIDB As WIDatabase
        Dim ColumnDataStr As String
        Dim ColumnDataInt As Integer
        Dim StrB As StringBuilder
        Dim DBInfo As CDatabaseInfo

        ColumnDataStr = ""

        ' Create DatabaseInfo object with login info  

        DBInfo = New CDatabaseInfo()
        DBInfo.DatabaseType = eDatabaseType.SQLite
        DBInfo.Location = "\WIDatabase\Samples"
        DBInfo.DBName = "SQLite.db3"
        DBInfo.Password = ""
        DBInfo.Port = 0
        DBInfo.Username = ""

        ' Create WIDatabase object 

        WIDB = New WIDatabase(DBInfo)

        ' Calling Select.Clear() ensures we starting with a new select statement. 

        WIDB.[Search].Clear()

        ' The Column Class is used to choose columns to be returned 

        WIDB.[Search].Column("AddressID")
        WIDB.[Search].Column("Address1")
        WIDB.[Search].Column("Address2")
        WIDB.[Search].Column("City")
        WIDB.[Search].Column("State")
        WIDB.[Search].Column("ZipCode")

        ' Select.Table: The 'Main' table from which the data will originate 

        WIDB.[Search].Table("tblAddress")

        ' Select.Condition: conditional clause to filter returned data. 

        WIDB.[Search].Condition(New CCondition("AddressID", eOperator.GreaterEqual, 22))
        WIDB.[Search].Condition(New CCondition("ZipCode", eOperator.GreaterEqual, "17601"))

        ' Select.Execute() prepares the statement to be sent to the Database 

        WIDB.[Search].Execute()

        Console.WriteLine("| AddressID | Address1 | Address2 | City | State | Zip |")

        ' Select.Read() reads the next row from the returned data 

        While WIDB.[Search].Read()
            StrB = New StringBuilder()

            ' Select.Get obtains the value of the named column via an out parameter 

            WIDB.[Search].Get("AddressID", ColumnDataInt)
            StrB.AppendFormat("| {0} ", ColumnDataInt)

            WIDB.[Search].Get("Address1", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("Address2", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("City", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("State", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            WIDB.[Search].Get("ZipCode", ColumnDataStr)
            StrB.AppendFormat("| {0} ", ColumnDataStr)

            Console.WriteLine(StrB.ToString())
        End While

        ' Good practice is to close the DB when finished 

        WIDB.Close()

    End Sub

End Module
