﻿/*******************************************************************************
File        : Program.cs
Description : 
--------------------------------------------------------------------------------
Functions:
--------------------------------------------------------------------------------
History:
2011/05/13 TPR Created
*******************************************************************************/
using System;
using Wiker.WIDatabase;
using System.Text;

namespace SimpleJoin
{
   /*******************************************************************************
   Class        : Program
   Description  : 
   --------------------------------------------------------------------------------
   History:
   2011/05/13 TPR Created
   *******************************************************************************/
   class Program
   {      
      /*******************************************************************************
      Function    : Main()
      Description : 
      Parameters  : string[] args - 
      Returns     : void
      --------------------------------------------------------------------------------
      History:
      2011/05/13 TPR Created
      *******************************************************************************/
      static void Main(string[] args)
      {                     
         WIDatabase WIDB;
         string ColumnDataStr;
         StringBuilder StrB;
         CDatabaseInfo DBInfo;

         /* Create DatabaseInfo object with login info  */
         DBInfo = new CDatabaseInfo();
         DBInfo.DatabaseType = eDatabaseType.SQLite;
         DBInfo.Location =  "\\WIDatabase\\Samples";
         DBInfo.DBName = "SQLite.db3";         
         DBInfo.Password = "";
         DBInfo.Port = 0;
         DBInfo.Username = "";

         /* Create WIDatabase object */
         WIDB = new WIDatabase(DBInfo);
                  
         /* Calling Select.Clear() ensures we starting with a new select statement. */ 
         WIDB.Search.Clear();

         /* The Column Class is used to choose columns to be returned */
         WIDB.Search.Column("City");
         WIDB.Search.Column("State");
         WIDB.Search.Column("ZipCode");
         WIDB.Search.Column("Name");
         WIDB.Search.Column("WebSite");

         /* Select.Table: The 'Main' table from which the data will originate */
         WIDB.Search.Table("tblAddress");

         /* Select.Join: Used to 'connect' related tables. */
         WIDB.Search.Join("tblCompany","AddressID", eOperator.Equal,"tblAddress","AddressID", eJoinType.Normal);

         /* Select.Execute() prepares the statement to be sent to the Database */
         WIDB.Search.Execute();
         
         Console.WriteLine("| City | State | ZipCode | Name | WebSite |");

         /* Select.Read() reads the next row from the returned data */
         while (WIDB.Search.Read())
            {
            StrB = new StringBuilder();

            /* Select.Get obtains the value of the named column via an out parameter */
            WIDB.Search.Get("City",out ColumnDataStr);
            StrB.AppendFormat("| {0} ",ColumnDataStr);

            WIDB.Search.Get("State",out ColumnDataStr);
            StrB.AppendFormat("| {0} ",ColumnDataStr);

            WIDB.Search.Get("ZipCode",out ColumnDataStr);
            StrB.AppendFormat("| {0} ",ColumnDataStr);

            WIDB.Search.Get("Name",out ColumnDataStr);
            StrB.AppendFormat("| {0} ",ColumnDataStr);

            WIDB.Search.Get("WebSite",out ColumnDataStr);
            StrB.AppendFormat("| {0} ",ColumnDataStr);

            Console.WriteLine(StrB.ToString());
            }
         
         /* Good practice is to close the DB when finished */
         WIDB.Close();
      }      
   }/* End Class */
}/* End NameSpace */
