﻿/*******************************************************************************
File        : Program.cs
Description : 
--------------------------------------------------------------------------------
Functions:
--------------------------------------------------------------------------------
History:
2011/05/13 TPR Created
*******************************************************************************/
using System;
using System.Collections.ObjectModel;
using Wiker.WIDatabase;
using System.Text;


namespace GetColumnInfo
{
   /*******************************************************************************
   Class        : Program
   Description  : 
   --------------------------------------------------------------------------------
   History:
   2011/05/13 TPR Created
   *******************************************************************************/
   class Program
   {      
      /*******************************************************************************
      Function    : Main()
      Description : 
      Parameters  : string[] args - 
      Returns     : void
      --------------------------------------------------------------------------------
      History:
      2011/05/13 TPR Created
      *******************************************************************************/
      static void Main(string[] args)
      {         
         WIDatabase WIDB;
         StringBuilder StrB;
         CDatabaseInfo DBInfo;
         Collection<TableColumnItem> ColumnInfo;

         /* Create DatabaseInfo object with login info  */
         DBInfo = new CDatabaseInfo();
         DBInfo.DatabaseType = eDatabaseType.SQLite;
         DBInfo.Location =  "\\WIDatabase\\Samples";
         DBInfo.DBName = "SQLite.db3";         
         DBInfo.Password = "";
         DBInfo.Port = 0;
         DBInfo.Username = "";


         /* Create WIDatabase object */
         WIDB = new WIDatabase(DBInfo);
         
         /* Get the Column info for the table */
         if (!WIDB.Table.GetColumnInfo("tblAddress", out ColumnInfo))
            {
            Console.WriteLine(string.Format("Failed To GetColumnInfo\n{0} - {1}", WIDB.LastError.ToString(), WIDB.LastErrorMessage));
            return;
            }

         Console.WriteLine("| DataTypeName | ColumnName | FieldType |");

         /* loop thru the data */
         foreach(TableColumnItem Item in ColumnInfo)
            {
            StrB = new StringBuilder();
            StrB.AppendFormat("| {0} ",Item.DataTypeName);
            StrB.AppendFormat("| {0} ",Item.ColumnName);
            StrB.AppendFormat("| {0} |",Item.FieldType);
            Console.WriteLine(StrB.ToString());
            }
         
         /* Good practice is to close the DB when finished */
         WIDB.Close();
      }
   }/* End Class */
}/* End NameSpace */
