﻿/*******************************************************************************
File        : Drop.cs
Description : 
--------------------------------------------------------------------------------
Functions:
--------------------------------------------------------------------------------
History:
2011/04/27 WLM Created
*******************************************************************************/
using System;
using System.Windows.Forms;
using System.Drawing;
using Wiker.WIDatabase;

namespace WIDatabaseSample
{
/*******************************************************************************
Class        : MainForm
Description  : 
--------------------------------------------------------------------------------
History:
2011/04/12 WLM Created
*******************************************************************************/
public partial class MainForm
{
/*******************************************************************************
Function    : DropTables()
Description : 
Parameters  : bool
Returns     : void
--------------------------------------------------------------------------------
History:
2011/04/27 WLM Created
*******************************************************************************/
public bool DropTables()
{
string Str;
CDatabaseInfo DatabaseInfo;
bool Result;

DatabaseInfo = GetDBInfo();

if (UseSELECT)
   Str = string.Format("DROP {0} Tables And Database Using SELECT", DatabaseInfo.DatabaseType.ToString());

else
   Str = string.Format("DROP {0} Tables And Database Using WIDatabase", DatabaseInfo.DatabaseType.ToString());

if (MessageBox.Show(Str, "", MessageBoxButtons.YesNo) == DialogResult.No)
   return(false);

/*----------------------------------------------------------------------------*/

if (UseSELECT)
   {
   switch (DatabaseInfo.DatabaseType)
      {
      case eDatabaseType.SQLite:
         Result = DropSQLiteSELECT(DatabaseInfo);
      break;

      case eDatabaseType.SQL:
         Result = DropSQLSELECT(DatabaseInfo);
      break;

      case eDatabaseType.MySql:
         Result = DropMySqlSELECT(DatabaseInfo);
      break;

      default:
         return(false);
      }
   }

else
   Result = DropWI();

return(Result);
}
/*******************************************************************************
Function    : DropWI()
Description : 
Parameters  : None
Returns     : bool
--------------------------------------------------------------------------------
History:
2011/05/06 WLM Created
*******************************************************************************/
public bool DropWI()
{
WIDatabase WIDB;
string Str;
//bool Result;

/* Create Connection And Open Database */
WIDB = new WIDatabase(GetDBInfo());

/* DROP TABLE tblAddress */
if (!WIDB.Table.Delete("tblAddress"))
   {
   Str = string.Format("Failed to DROP table tblAddress\nLastError = {0}\n{1}",
      WIDB.LastError.ToString(), WIDB.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* DROP TABLE tblCompany */
if (!WIDB.Table.Delete("tblCompany"))
   {
   Str = string.Format("Failed to DROP table tblCompany\nLastError = {0}\n{1}",
      WIDB.LastError.ToString(), WIDB.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* DROP TABLE tblImage */
if (!WIDB.Table.Delete("tblImage"))
   {
   Str = string.Format("Failed to DROP table tblImage\nLastError = {0}\n{1}", WIDB.LastError.ToString(),
      WIDB.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* DROP TABLE tblPerson */
if (!WIDB.Table.Delete("tblPerson"))
   {
   Str = string.Format("Failed to DROP table tblPerson\nLastError = {0}\n{1}", WIDB.LastError.ToString(),
      WIDB.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

/* DROP TABLE tblPhone */
if (!WIDB.Table.Delete("tblPhone"))
   {
   Str = string.Format("Failed to DROP table tblPhone\nLastError = {0}\n{1}", WIDB.LastError.ToString(),
      WIDB.LastErrorMessage);
   MessageBox.Show(Str);
   return(false);
   }

return(true);
}
} /* End Of Class MainForm */
} /* End Of NameSpace WIDatabaseSample */